<template>
    <div class="">
              <!-- Modal dbt -->
              <b-modal @shown="setTitle" @hidden="reset" size="xl"  ref="inputModal" id="my-modal" :title="title"  :centered="true" :scrollable="true">
                <form class="" method="POST" @keydown="form.errors.clear($event.target.name)"  @change="form.errors.clear($event.target.name)">
                            <div class="form-group">
                                <div class="row">

                                    <div class="col">
                                        <div class="form-check mt-1 ">
                                            <input class="form-check-input " type="checkbox" id="inlineCheckbox3" v-model="form.avec_chauffeur" name="avec_chauffeur" :checked="form.avec_chauffeur">
                                                <label class="form-check-label" for="inlineCheckbox3">Avec Chauffeur ?</label>
                                            </div>
                                        <div class="form-check  mt-1 ">
                                            <input class="form-check-input " type="checkbox" id="inlineCheckbox2" v-model="form.longue_duree" name=".longue_duree" :checked="form.longue_duree">
                                                <label class="form-check-label" for="inlineCheckbox2">Longue durée ?</label>
                                            </div>
                                        <div class="form-check  mt-1 ">
                                            <input class="form-check-input " type="checkbox" id="inlineCheckbox1" v-model="form.ancien_client"
                                                name="client.ancien_client" :checked="form.ancien_client" @change="fixChange">
                                                <label class="form-check-label" for="inlineCheckbox1">Nouveau client ?</label>
                                        </div>
                                        <div class="form-check mt-1 ">
                                            <input class="form-check-input " type="checkbox" id="inlineCheckbox4" v-model="form.client_est_chauffeur" name="client_est_chauffeur" :checked="form.client_est_chauffeur">
                                                <label class="form-check-label" for="inlineCheckbox4">Le client est le chauffeur ?</label>
                                        </div>
                                    </div>
                                    <div class="col-md-4">
                                        <label class="">Date de début de la location</label>
                                        <datetime id="date_fin" placeholder="Date de début de la location " ref="date_dbt" v-model="date_dbt" :min-datetime="min_date" :max-datetime="max_date" @input="datepickerEvent($event,'date_dbt')"  class="theme-rouge"  type="datetime" :input-class="['form-control input','input']"   :phrases="{ cancel: 'Annuler',ok: 'Ok'}"></datetime>

                                        <!-- <VueCtkDateTimePicker format='YYYY-MM-DD hh:mm' @input="updateDate($event,'date_dbt')"
                                        buttonColor="rgb(129, 135, 140)"
                                        buttonNowTranslation="Maintenant"
                                        input-size="sm"
                                        id="dbt" color="rgb(129, 135, 140)" locale="fr" label="Choisissez la date de début"  v-model="form.date_dbt" :no-error="form.errors.has('date_dbt')" :no-label="true" /> -->
                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_dbt')" v-text="form.errors.get('date_dbt')"></span>

                                    </div>
                                    <div class="col-md-4">
                                        <label class="">Date de fin de la location</label>
                                        <datetime id="date_dbt" placeholder="Date de fin de la location " ref="date_fin" v-model="date_fin" :min-datetime="min_date_fin"  @input="datepickerEvent($event,'date_fin')"  class="theme-rouge"  type="datetime" :input-class="['form-control','input']"   :phrases="{ cancel: 'Annuler',ok: 'Ok'}"></datetime>

                                        <!-- <VueCtkDateTimePicker format='YYYY-MM-DD hh:mm'
                                        input-size="sm"
                                        buttonColor="rgb(129, 135, 140)"
                                        buttonNowTranslation="Maintenant"
                                        @input="updateDate($event,'date_fin')" id="fin" color="rgb(129, 135, 140)" locale="fr" label="Choisissez la date de retour" v-model="form.date_fin" :no-error="form.errors.has('date_fin')" :no-label="true"/> -->
                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_fin')" v-text="form.errors.get('date_fin')"></span>
                                    </div>
                                    <div class="col-md-2">
                                        <label class="">Nbr de jours</label>
                                        <input class="form-control" type="text" disabled v-model="duree">
                                    </div>
                                </div>
                            </div>
                            <div class="form-group mb-2">
                            <div class="row">

                                <div class="col-md-4" v-if="!ancien_client">
                                        <label class="">Client</label>
                                        <multi-select :disabled="ancien_client" :class="['',form.errors.has('client_id')?'is-invalid':'']"
                                            no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                            v-model="selectedClient"  :options="options.clients"
                                            @input="onClientSelect"
                                            :show-labels="false" :searchable="true" :clear-on-select="false"
                                            :close-on-select="true"  placeholder="Rechercher le client par son nom" label="nomComplet" track-by="id">
                                        </multi-select>
                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('client_id')" v-text="form.errors.get('client_id')"></span>
                                </div>
                                <div class="col">
                                            <label class="">Prénom du client</label>
                                            <input :disabled="!ancien_client" :class="['form-control',form.errors.has('client.prenom')?'is-invalid':'']" name="client.prenom" v-model="form.client.prenom" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.prenom')" v-text="form.errors.get('client.prenom')"></span>
                                </div>
                                <div class="col">
                                            <label class="">Nom du client</label>
                                            <input :disabled="!ancien_client"  :class="['form-control',form.errors.has('client.nom')?'is-invalid':'']"  name="client.nom" v-model="form.client.nom" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.nom')" v-text="form.errors.get('client.nom')"></span>
                                </div>
                                <div class="col">
                                            <label class="">Adresse du client</label>
                                            <input :disabled="!ancien_client"  :class="['form-control',form.errors.has('client.adresse')?'is-invalid':'']"  name="client.adresse" v-model="form.client.adresse" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.adresse')" v-text="form.errors.get('client.adresse')"></span>
                                </div>
                                <div class="col">
                                    <label class="">Téléphone du client</label>
                                            <input :disabled="!ancien_client"  :class="['form-control',form.errors.has('client.telephone1')?'is-invalid':'']"  name="client.telephone1" v-model="form.client.telephone1" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.telephone1')" v-text="form.errors.get('client.telephone1')"></span>
                                </div>
                                </div>
                            </div>
                            <div class="form-group" >
                                <div class="row">
                                      <div class="col-md-6" v-show="form.ancien_client">
                                         <div class="row">
                                             <div class="col">
                                              <label class="">Type de piece</label>
                                              <multi-select :class="['',form.errors.has('client.type_piece_identite')?'is-invalid':'']" 
                                                  no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                  v-model="form.client.type_piece_identite"  :options="['CNI','Passeport','Récepissé CNI','Autres']" 
                                                  :show-labels="false" :searchable="false" :clear-on-select="false" 
                                                  :close-on-select="true"  placeholder="Choisissez le type de pièce">
                                              </multi-select>
                                              <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.type_piece_identite')" v-text="form.errors.get('client.type_piece_identite')"></span>
                                          </div>
                                          <div class="col ">
                                              <label class="">Copie de la pièce d'identité</label>
                                              <document-input @file-has-changed="onDocumentInputChanged" placeholder="Choissisez votre fichier"></document-input>
                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.piece_identite')" v-text="form.errors.get('client.piece_identite')"></span>

                                          </div>
                                         </div>
                                      </div>
                                      <div :class="[row_class]">
                                        <div class="row">
                                          <div class="col" v-if="!form.avec_chauffeur">
                                            <label class="">Nom du chauffeur</label>
                                            <input  :disabled="form.client_est_chauffeur" :class="['form-control',form.errors.has('nom_chauffeur')?'is-invalid':'']"  name="nom_chauffeur" v-model="form.nom_chauffeur" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur')" v-text="form.errors.get('nom_chauffeur')"></span>
                                        </div>
                                        <div class="col" v-if="!form.avec_chauffeur">
                                            <label class="">Nom du 2éme chauffeur</label>
                                            <input :disabled="form.nom_chauffeur==''"  :class="['form-control',form.errors.has('nom_chauffeur_2')?'is-invalid':'']" name="nom_chauffeur_2" v-model="form.nom_chauffeur_2" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur_2')" v-text="form.errors.get('nom_chauffeur_2')"></span>
                                        </div>
                                        <div :class="[ !form.avec_chauffeur ? 'col' : 'col-md-12']" v-if="form.avec_chauffeur">
                                          <label class="">Nom du chauffeur</label>
                                          <multi-select  :class="['',form.errors.has('chauffeur_id')?'is-invalid':'']" 
                                              no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                              v-model="selectedChauffeur"  :options="options.chauffeurs" 
                                              @input="onChauffeurSelect"
                                              :show-labels="false" :searchable="true" :clear-on-select="false" 
                                              :close-on-select="true"  placeholder="Rechercher le chauffeur" label="nomComplet" track-by="id">
                                          </multi-select>
                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('chauffeur_id')" v-text="form.errors.get('chauffeur_id')"></span>
                                          </div>
                                        </div>
                                      </div>
                                </div>
                            </div>
                            <div class="form-group mb-0">
                                <div class="row">

                                        <div class="col-md-6">

                                                <div class=" form-group row">
                                                            <div class="col">
                                                                <label class="">Frais de livraison </label>
                                                                <div class="input-group">
                                                                <div class="input-group-prepend">
                                                                    <span class="input-group-text">
                                                                    <input type="checkbox" name="livraison_effective"  v-model="form.livraison_effective">
                                                                    </span>
                                                                </div>
                                                                <input  disabled class="form-control " :class="['form-control',form.errors.has('frais_livraison')?'is-invalid':'']"  name="frais_livraison" v-model="form.frais_livraison" type="text"/>
                                                                </div>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('frais_livraison')" v-text="form.errors.get('frais_livraison')"></span>
                                                            </div>
                                                            <div class="col">
                                                                <label class="">Lavage</label>
                                                                <input  class="form-control " :class="['form-control',form.errors.has('lavage_carburant')?'is-invalid':'']"  name="lavage_carburant" v-model="form.lavage_carburant" type="text"/>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('lavage_carburant')" v-text="form.errors.get('lavage_carburant')"></span>
                                                            </div>
                                                </div>
                                            <div class="row">
                                                <div class=" form-group col-md-12">
                                                    <label class="">Observations</label>
                                                    <textarea style="min-height:103px" class="form-control " :class="['form-control',form.errors.has('observation')?'is-invalid':'']"  name="observation" v-model="form.observation" type="text"></textarea>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('observation')" v-text="form.errors.get('observation')"></span>
                                                    </div>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                                      <div class=" form-group row">
                                                                <div class="col">
                                                                    <label class="">Zone de location</label>
                                                        <select :class="['form-control',form.errors.has('zone_location')?'is-invalid':'']"  name="zone_location" v-model="form.zone_location" >
                                                            <option value="">Choissisez la zone</option>
                                                            <option :value="zone" v-for="(zone,key) in ['Libreville','Owendo','Akanda','Port-Gentil','Lambaréné','Franceville','Autres']" :key="key" > {{ zone }}</option>
                                                        </select>
                                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('zone_location')" v-text="form.errors.get('zone_location')"></span>
                                                            </div>
                                                    <div class="col">
                                                        <label for="">Niveau de Carburant</label>
                                                        <select v-model="form.niveau_carburant" :class="['form-control',form.errors.has('niveau_carburant')?'is-invalid':'']"  name="niveau_carburant" placeholder="Le niveau de carburant" >
                                                            <option value="">Choissisez le niveau</option>
                                                            <option :value="niveau" v-for="(niveau,key) in niveaux" :key="key" > {{ niveau }}</option>
                                                        </select>
                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('niveau_carburant')" v-text="form.errors.get('niveau_carburant')"></span>
                                                    </div>
                                                </div>
                                                <div class="form-group row">

                                                    <div class="col">
                                                        <label class="">Prix par jour</label>
                                                        <input  class="form-control " :class="['form-control',form.errors.has('tarif')?'is-invalid':'']"  name="tarif" v-model="form.tarif" type="text"/>
                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('tarif')" v-text="form.errors.get('tarif')"></span>
                                                    </div>
                                                      <div class="col">
                                                        <label class="">Montant</label>
                                                        <input  class="form-control " :class="['form-control',form.errors.has('montant')?'is-invalid':'']"  name="montant" v-model="htc" type="text"/>
                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('montant')" v-text="form.errors.get('montant')"></span>
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                  <div class="col">
                                                      <label class="">Statut du payement</label>
                                                        <select @change="onStatutSelect" v-model="form.statut_payement_id" :class="['form-control',form.errors.has('statut_payement_id')?'is-invalid':'']"  name="statut_payement_id" >
                                                            <option value="">Choissisez le statut</option>
                                                            <option :value="payement.id" v-for="(payement,key) in options.payements" :key="key" > {{ payement.nature }}</option>
                                                        </select>
                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('statut_payement_id')" v-text="form.errors.get('statut_payement_id')"></span>

                                                        </div>
                                                        <div class="col" v-if="avance">
                                                            <label class="">Avance</label>
                                                            <input placeholder="Entrez le montant" class="form-control " :class="['form-control',form.errors.has('avance')?'is-invalid':'']"  name="avance" v-model="form.avance" type="text"/>

                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('avance')" v-text="form.errors.get('avance')"></span>

                                                        </div>
                                                        <div class="col" v-if="avance">
                                                            <label class="">Reste à payer</label>
                                                            <input disabled  class="form-control " :class="['form-control']"  v-model="reste"  type="text"/>
                                                        </div>
                                                </div> 
                                        </div>
                                </div>
                            </div>

               </form>
                   <template v-slot:modal-footer="">
                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button @click="onSubmit()" type="button" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                            <button @click="reset()" type="button" :class="['btn btn-secondary btn-small mr-2']" :disabled="isLoading">Fermer</button>
											</div>
                  </template>
            </b-modal>
            <!-- Modal fin -->
</div>
</template>

<script>
   import Form from "./../classes/Form"
   import Master from "./../pages/Master.vue";
   import DocumentInput from "./DocumentInput"


    export default {
        mixins: [Master],
        data(){
            return{

                url:"/api/locations",
                title:"Mise en Location",
                niveaux:['1/4','1/2','3/4','plein'],
                date_fin:"",
                min_date_fin:"",
                date_dbt:"",
                min_date:moment().format(),
                max_date:"",
                options:{
                  clients:[],
                  vehicules:[],
                  chauffeur:[],
                  payements:[]
                },
                selectedClient:"",
                selectedChauffeur:"",

                selectedStatut:'',
                vehicule:"",
                isLoading:false,
                form : new Form({
                  avec_chauffeur:false,
                  client_id:"",
                  vehicule_id:"",
                  date_dbt:"",
                  date_fin:"",
                  nom_chauffeur:"",
                  nom_chauffeur_2:"",
                  statut_payement_id:"",
                   avance:'',
                  chauffeur_id:"",
                  livraison_effective:false,
                  client_est_chauffeur: false,
                  frais_livraison:0,
                  lavage_carburant:10000,
                  niveau_carburant:"",
                  nbr_jour : 0,
                  observation:"",
                  tarif:"",
                  montant:"",
                  longue_duree:false,
                  ancien_client:false,
                  zone_location:'',
                    client: {
                       nom:"",
                       prenom:"",
                       adresse:'',
                       telephone1:'',
                        type_piece_identite:'',
                       piece_identite:''
                    },
                    vehicule :{
                       marque:"",
                       tvehicule:"",
                       immatriculation:"",
                       tarif:""
                    }
                }),

            }
        },
        created()
        {
           this.fetchOptions()
        },
        mounted() {
               window.event.$on("mettre-en-location-event",(e)=>
               {
                  this.vehicule = e
                  this.showModalOnCreate()
                  this.onVehiculeSelect(e)

               })
        },
        computed:
         {
              nom_chauffeur_live: function(value) 
            {
               var fullname = ""
               if(this.form.client_est_chauffeur)
               {
                 if(isDefined(this.form.client.nom) && isDefined(this.form.client.prenom))
                 {
                    fullname = this.form.client.nom+" "+this.form.client.prenom
                    this.form.nom_chauffeur = fullname
                 }
                if(!isDefined(this.form.client.nom) && !isDefined(this.form.client.prenom) && this.form.client_est_chauffeur && this.form.avec_chauffeur)
                 {
                    this.form.nom_chauffeur = ""
                 }
               }
               return fullname;
            },
            row_class()
            {
              if(this.form.ancien_client == false && !this.form.avec_chauffeur)
              return 'col-md-12'
              else if(this.form.ancien_client == true && this.form.avec_chauffeur)
              return 'col-md-6'
              else if(this.form.ancien_client == true && !this.form.avec_chauffeur)
              return 'col-md-6'
              else
              return 'col-md-12'



            },
            ModalAction ()
            {
              return  this.modeEdit ? " Valider"  : "Valider"
            },
             ancien_client()
            {

              return this.form.ancien_client==true ? true : false

            },
             duree()
            {

              if(this.form.date_dbt!="" && this.form.date_dbt!= null && this.form.date_dbt!=undefined && this.form.date_fin!="" && this.form.date_fin!=null && this.form.date_fin!=undefined)
                {
                  var start = moment(this.form.date_dbt,"YYYY-MM-DD"); //todays date
                  var end = moment(this.form.date_fin,"YYYY-MM-DD"); // another date
                  var duration = moment.duration(end.diff(start));
                  this.form.nbr_jour = duration.asDays();

                  return  this.form.nbr_jour
                }
              else
                return 0

            }
            ,
            avance()
            {
                  if(isDefined(this.selectedStatut))
                  {
                       if(this.selectedStatut.nature=="avance")
                       return true
                  }
                 return false
            },
            reste()
            {
                 if(this.avance && this.form.nbr_jour>=1 && isDefined(this.form.avance))
                 {
                   return this.form.montant-this.form.avance;
                 }
                 return ""
            },
             htc()
            {
               var montant = 0
           
                      if(this.duree<=0)
                      {
                        this.form.montant = 0
                        montant = 0
                      }
                      else
                      {
                         this.form.montant = this.duree * this.form.tarif + (this.form.frais_livraison  + this.form.lavage_carburant)
                         montant = this.form.montant
                      }
               return montant
            }
         },
        methods:
        {
              onStatutSelect(e)
            {
               if(isDefined(e.target.value))
               {
                  this.selectedStatut = this.options.payements.find(ex => { return ex.id == e.target.value })
                  console.log(this.selectedStatut);
                  if(this.selectedStatut=="payé")
                  this.form.reste_a_payer = 0
               }
               else
               {
                 this.form.statut_payement_id_id = ""
  
               }


              if(this.form.errors.has('statut_payement_id') )
              {
                  this.form.errors.clear('statut_payement_id')
              }
            },
            //gere les datepickers
            datepickerEvent(event,name)
            {        if(isDefined(event))
                    {
                          if(name=='date_dbt')
                         {
                            var instant = moment(event)
                            this.form[name] = instant.format('YYYY-MM-DD hh:mm')
                            this.min_date_fin = moment(this.form[name]).add(1,'days').format()

                            this.form.date_fin =instant.add(1,'days').format('YYYY-MM-DD hh:mm')
                            this.date_fin = instant.format()

                            if(this.form.errors.has('date_fin'))
                            {
                              this.form.errors.clear('date_fin')
                            }
                         }
                         else if(name='date_fin')
                         {
                            this.form[name] = moment(event).format('YYYY-MM-DD hh:mm')
                            this.max_date = moment(this.form[name]).subtract(1,'days').format()
                            
                         }
                    } 
                    else
                    {
                        
                        this.min_date = moment().format()
             
                    }  
                    this.form.checkError(name)
         

            },
            //Retire les erreurs des dates
            updateDate(e,val)
            {
                  if(this.form.errors.has(val))
                    this.form.errors.clear(val)

            },
            onChauffeurSelect(e)
            {
               if(e!=null)
               {
                this.form.chauffeur_id = e.id
               }
               else
               {
                 this.form.chauffeur_id = ""
                if(this.form.client_est_chauffeur)
                {
                    this.form.nom_chauffeur =""
                }  
               }


              if(this.form.errors.has('chauffeur_id') )
              {
                  this.form.errors.clear('chauffeur_id')
              }
            },
            //Ecoute les events du doc input file
            onDocumentInputChanged(name)
            {
               if(isDefined(name))
               {
                   this.form.client.piece_identite = name 
                   
               }
               if(this.form.errors.has('client.piece_identite'))
                  this.form.errors.clear('client.piece_identite')
            },
            fixChange(e)
            {
                if(e.target.checked==false)
                {
                    this.form.client_id = ""
                }

                this.form.client.nom=""
                this.form.client.prenom=""
                this.form.client.adresse=""
                this.form.client.telephone1=""
                this.selectedClient = ""
                if(this.form.client_est_chauffeur)
                this.form.nom_chauffeur = ""

                if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
                {
                    this.form.errors.clear('client_id')
                    this.form.errors.clear('client.nom')
                    this.form.errors.clear('client.prenom')
                    this.form.errors.clear('client.adresse')
                    this.form.errors.clear('client.telephone1')
                }

            },
            //Quand on selectionne un client
            onClientSelect(e)
            {
                    this.form.client_id = e.id
                    this.form.client.nom= e.nom
                    this.form.client.prenom= e.prenom
                    this.form.client.adresse= e.adresse
                    this.form.client.telephone1= e.telephone1

                if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
                {
                    this.form.errors.clear('client_id')
                    this.form.errors.clear('client.nom')
                    this.form.errors.clear('client.prenom')
                    this.form.errors.clear('client.adresse')
                    this.form.errors.clear('client.telephone1')
                }
            },
              onVehiculeSelect(e)
            {
               this.form.vehicule_id = e.id
               this.form.vehicule.marque = e.marque.libelle
               this.form.vehicule.tvehicule = e.type_vehicule.libelle
               this.form.vehicule.immatriculation = e.plaque_immatriculation
               this.form.vehicule.tarif = e.tarif

              if(this.form.errors.has('vehicule_id') )
              {
                  this.form.errors.clear('vehicule_id')
              }
            },
            monnaie: function(value)
            {
               return  numeral(value).format('0,0');
            },
            setTitle: function()
            {
               this.title +=" : "+this.vehicule.libelle
            },

            showModalOnCreate()
            {

                this.modeEdit = false
                this.reset()

                this.$refs['inputModal'].show()

            },
              //Initialisation du formulaire
              reset()
             {
                  this.modeEdit = false
                  this.isLoading = false
                  this.form.client.nom =""
                  this.form.client.prenom=""
                  this.form.client.type_piece_identite=""
                  this.form.client.piece_identite=""
                  this.form.client.adresse =""
                  this.form.client.telephone1 =""
                  this.form.ancien_client =false
                  this.form.avec_chauffeur = false
                  this.form.client_est_chauffeur = false
                  this.form.longue_duree = false

                  this.selectedClient = ""
                  this.form.date_dbt = ""
                  this.form.date_fin = ""
                  this.date_fin = ""
                  this.date_dbt = ""
                  this.form.nom_chauffeur = ""
                  this.form.nom_chauffeur_2 = ""
                  this.form.zone_location = ""
                  this.selectedStatut=""
                  this.form.niveau_carburant = ""
                  this.form.statut_payement_id ="";
                  log(this.form.niveau_carburant)
                  this.form.livraison_effective = false
                  this.form.errors.clearAll()
                  if(this.vehicule!="" && this.vehicule!=null && this.vehicule!=undefined)
                  {
                       this.form.tarif = this.vehicule.tarif
                  }
                  else
                  {
                    this.form.tarif = 0
                  }
                  this.$refs['inputModal'].hide()
             },

             //Charge les options
              fetchOptions()
             {
               axios.get("/api/dispatcher/options/locations").then((response) =>
                {

                      this.options.clients = response.data.clients
                      this.options.vehicules = response.data.vehicules
                      this.options.chauffeurs = response.data.chauffeurs
                      this.options.payements = response.data.payements


                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                      this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
                          //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Requête ajax
                this.form.post(this.url).then((response) =>
                {
                  if(response.success)
                  {
                        // on ramène les données sur la page 1
                        flash("<span>Mise en location <strong>enregistrée</strong></span>")
                        this.$emit('mise-en-location-event',response.entity)
                  }
                  else
                  {
                        flash("<span>Mise en location  <strong> impossible</strong></span>","error")
                  }
                 this.reset()

                },
                (error) =>
                {
                  this.isLoading = false
                });
             }
       },
        components:
        {
          DocumentInput
        },
        watch:
        {
         "form.livraison_effective":function(value)
          {
            if(value==true)
             this.form.frais_livraison = 5000
             else
              this.form.frais_livraison = 0
          },
         "form.niveau_carburant":function(value)
          {
            if(this.form.errors.has('niveau_carburant'))
            {
              this.form.errors.clear('niveau_carburant')
            }
          },
          "form.client.type_piece_identite":function(value)
          {
            if(this.form.errors.has('client.type_piece_identite'))
            {
              this.form.errors.clear('client.type_piece_identite')
            }
          },
          "form.ancien_client":function(value)
          {
            if(this.form.errors.has('client.type_piece_identite'))
            {
              this.form.errors.clear('client.type_piece_identite')
            }
            if(this.form.errors.has('client.piece_identite'))
            {
              this.form.errors.clear('client.piece_identite')
            }
          },
        "form.client.piece_identite":function(value)
          {
            if(this.form.errors.has('client.piece_identite'))
            {
              this.form.errors.clear('client.piece_identite')
            }
          },
          "form.avec_chauffeur":function(value)
          {
            if(value)
            this.form.client_est_chauffeur = false;
            if(this.form.errors.has('nom_chauffeur'))
            {
              this.form.errors.clear('nom_chauffeur')
            }
            if(this.form.errors.has('chauffeur_id'))
            {
                  this.form.errors.clear('chauffeur_id')
            }
          },
          "form.client_est_chauffeur":function(value)
          {
                if(value)
                {
                  if(this.form.client.nom!="" && this.form.client.prenom!="")
                  {
                      this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                      if(this.form.errors.has('nom_chauffeur'))
                      {
                        this.form.errors.clear('nom_chauffeur')
                      }
                  }
                  if(this.form.avec_chauffeur )
                  this.form.avec_chauffeur = false;

                  if(this.form.errors.has('chauffeur_id'))
                  {
                        this.form.errors.clear('chauffeur_id')
                  }
                }
          },
          client_est_chauffeur:function(value)
          {
            if(value==true)
             {
               if(this.form.client.nom!="" && this.form.client.prenom!="")
               {
                  this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                  if(this.form.errors.has('nom_chauffeur'))
                  {
                    this.form.errors.clear('nom_chauffeur')
                  }
               }
               this.form.avec_chauffeur = false;
             }
             else
             {
               this.form.nom_chauffeur = ""
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
             }
          }
        }
    }
</script>
<style lang="scss" scoped>
  #my-modal input[type="text"],#my-modal select
  {
        height: 30px;
        min-height: 30px;
  }
  .form-group {
    margin-bottom: .8rem;
}
#my-modal .modal-body
{
  overflow-x: hidden !important;
}
.modal-dialog-scrollable .modal-body {
      overflow-y: auto;
        overflow-x: hidden !important;


}
</style>
